#include <kdialog.h>
#include <klocale.h>

/****************************************************************************
** Form implementation generated from reading ui file 'ksnapshotwidget.ui'
**
** Created: 2016-04-15T21:19:40
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "ksnapshotwidget.h"

#include <qvariant.h>
#include <kdialog.h>
#include <kiconloader.h>
#include <kglobalsettings.h>
#include <qframe.h>
#include <qspinbox.h>
#include <qlabel.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <kpushbutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>

#include "ksnapshot.h"
#include "ksnapshotwidget.ui.h"
/*
 *  Constructs a KSnapshotWidget as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
KSnapshotWidget::KSnapshotWidget( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "KSnapshotWidget" );
    KSnapshotWidgetLayout = new QGridLayout( this, 1, 1, 0, KDialog::spacingHint(), "KSnapshotWidgetLayout"); 

    lblImage = new KSnapshotPreview( this, "lblImage" );
    lblImage->setMinimumSize( QSize( 200, 130 ) );

    KSnapshotWidgetLayout->addMultiCellWidget( lblImage, 0, 0, 0, 2 );

    line1 = new QFrame( this, "line1" );
    line1->setFrameShape( QFrame::HLine );
    line1->setFrameShadow( QFrame::Sunken );
    line1->setFrameShape( QFrame::HLine );

    KSnapshotWidgetLayout->addMultiCellWidget( line1, 1, 1, 0, 3 );

    spinDelay = new QSpinBox( this, "spinDelay" );

    KSnapshotWidgetLayout->addWidget( spinDelay, 3, 1 );

    lblDelay = new QLabel( this, "lblDelay" );

    KSnapshotWidgetLayout->addWidget( lblDelay, 3, 0 );

    textLabel1 = new QLabel( this, "textLabel1" );

    KSnapshotWidgetLayout->addWidget( textLabel1, 2, 0 );
    Spacer1 = new QSpacerItem( 156, 16, QSizePolicy::Expanding, QSizePolicy::Minimum );
    KSnapshotWidgetLayout->addMultiCell( Spacer1, 3, 3, 2, 3 );

    cbIncludeDecorations = new QCheckBox( this, "cbIncludeDecorations" );
    cbIncludeDecorations->setChecked( TRUE );

    KSnapshotWidgetLayout->addMultiCellWidget( cbIncludeDecorations, 4, 4, 0, 3 );

    comboMode = new QComboBox( FALSE, this, "comboMode" );

    KSnapshotWidgetLayout->addMultiCellWidget( comboMode, 2, 2, 1, 3 );

    layout1 = new QVBoxLayout( 0, 0, KDialog::spacingHint(), "layout1"); 

    btnNew = new KPushButton( this, "btnNew" );
    btnNew->setIconSet( QIconSet( SmallIconSet( "ksnapshot", 32 ) ) );
    layout1->addWidget( btnNew );
    Spacer6 = new QSpacerItem( 16, 16, QSizePolicy::Minimum, QSizePolicy::Expanding );
    layout1->addItem( Spacer6 );

    btnSave = new KPushButton( this, "btnSave" );
    btnSave->setIconSet( QIconSet( SmallIconSet( "filesave" ) ) );
    layout1->addWidget( btnSave );

    btnCopy = new KPushButton( this, "btnCopy" );
    btnCopy->setIconSet( QIconSet( SmallIconSet( "editcopy" ) ) );
    layout1->addWidget( btnCopy );

    btnPrint = new KPushButton( this, "btnPrint" );
    btnPrint->setIconSet( QIconSet( SmallIconSet( "fileprint" ) ) );
    layout1->addWidget( btnPrint );

    KSnapshotWidgetLayout->addLayout( layout1, 0, 3 );
    languageChange();
    resize( QSize(356, 226).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( comboMode, SIGNAL( activated(int) ), this, SLOT( slotModeChanged(int) ) );
    connect( btnNew, SIGNAL( clicked() ), this, SLOT( slotNewClicked() ) );
    connect( btnPrint, SIGNAL( clicked() ), this, SLOT( slotPrintClicked() ) );
    connect( btnSave, SIGNAL( clicked() ), this, SLOT( slotSaveClicked() ) );
    connect( btnCopy, SIGNAL( clicked() ), this, SLOT( slotCopyClicked() ) );
    connect( lblImage, SIGNAL( startDrag() ), this, SLOT( slotStartDrag() ) );

    // tab order
    setTabOrder( btnNew, btnSave );
    setTabOrder( btnSave, btnCopy );
    setTabOrder( btnCopy, btnPrint );
    setTabOrder( btnPrint, comboMode );
    setTabOrder( comboMode, spinDelay );
    setTabOrder( spinDelay, cbIncludeDecorations );

    // buddies
    lblDelay->setBuddy( spinDelay );
    textLabel1->setBuddy( comboMode );
}

/*
 *  Destroys the object and frees any allocated resources
 */
KSnapshotWidget::~KSnapshotWidget()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void KSnapshotWidget::languageChange()
{
    QWhatsThis::add( lblImage, tr2i18n( "This is a preview of the current snapshot.\n"
"\n"
"The image can be dragged to another application or document to copy the full screenshot there. Try it with the Konqueror file manager.\n"
"\n"
"You can also copy the image to the clipboard by pressing Ctrl+C." ) );
    spinDelay->setSuffix( tr2i18n( " sec" ) );
    spinDelay->setSpecialValueText( tr2i18n( "No delay" ) );
    QToolTip::add( spinDelay, tr2i18n( "Snapshot delay in seconds" ) );
    QWhatsThis::add( spinDelay, tr2i18n( "<qt>\n"
"This is the number of seconds to wait after clicking the <i>New Snapshot</i> button before taking the snapshot.\n"
"<p>\n"
"This is very useful for getting windows, menus and other items on the screen set up just the way you want.\n"
"<p>\n"
"If <i>no delay</i> is set, the program will wait for a mouse click before taking a snapshot.\n"
"</p>\n"
"</qt>" ) );
    lblDelay->setText( tr2i18n( "Snapshot &delay:" ) );
    textLabel1->setText( tr2i18n( "Cap&ture mode:" ) );
    cbIncludeDecorations->setText( tr2i18n( "Include &window decorations" ) );
    QWhatsThis::add( cbIncludeDecorations, tr2i18n( "When enabled, snapshot of a window will also include the window decorations" ) );
    comboMode->clear();
    comboMode->insertItem( tr2i18n( "Full Screen" ) );
    comboMode->insertItem( tr2i18n( "Window Under Cursor" ) );
    comboMode->insertItem( tr2i18n( "Region" ) );
    comboMode->insertItem( tr2i18n( "Section of Window" ) );
    QWhatsThis::add( comboMode, tr2i18n( "<qt>Using this menu, you can select from the four following snapshot modes:\n"
"<p>\n"
"<b>Full Screen</b> - captures the entire desktop.<br>\n"
"<b>Window Under Cursor</b> - captures only the window (or menu) that is under the mouse cursor when the snapshot is taken.<br>\n"
"<b>Region</b> - captures only the region of the desktop that you specify. When taking a new snapshot in this mode you will be able to select any area of the screen by clicking and dragging the mouse.</p>\n"
"<b>Section of Window</b> - captures only a section of the window. When taking a new snapshot in this mode you will be able to select any child window by moving the mouse over it.</p></qt>" ) );
    btnNew->setText( tr2i18n( "&New Snapshot" ) );
    QWhatsThis::add( btnNew, tr2i18n( "Click this button to take a new snapshot." ) );
    btnSave->setText( tr2i18n( "&Save As..." ) );
    QWhatsThis::add( btnSave, tr2i18n( "Click this button to save the current snapshot. To quickly save the snapshot without showing the file dialog, press Ctrl+Shift+S. The filename is automatically incremented after each save." ) );
    btnCopy->setText( tr2i18n( "&Copy to Clipboard" ) );
    QWhatsThis::add( btnCopy, tr2i18n( "Click this button to copy the current snapshot to the clipboard." ) );
    btnPrint->setText( tr2i18n( "&Print..." ) );
    QWhatsThis::add( btnPrint, tr2i18n( "Click this button to print the current screenshot." ) );
}

/****************************************************************************
** KSnapshotWidget meta object code from reading C++ file 'ksnapshotwidget.h'
**
** Created: Fri Apr 15 21:19:40 2016
**      by: The Qt MOC ($Id: qt/moc_yacc.cpp   3.3.8   edited Feb 2 14:59 $)
**
** WARNING! All changes made in this file will be lost!
*****************************************************************************/

#undef QT_NO_COMPAT
#include "ksnapshotwidget.h"
#include <qmetaobject.h>
#include <qapplication.h>

#include <private/qucomextra_p.h>
#if !defined(Q_MOC_OUTPUT_REVISION) || (Q_MOC_OUTPUT_REVISION != 26)
#error "This file was generated using the moc from 3.3.8d. It"
#error "cannot be used with the include files from this version of Qt."
#error "(The moc has changed too much.)"
#endif

const char *KSnapshotWidget::className() const
{
    return "KSnapshotWidget";
}

QMetaObject *KSnapshotWidget::metaObj = 0;
static QMetaObjectCleanUp cleanUp_KSnapshotWidget( "KSnapshotWidget", &KSnapshotWidget::staticMetaObject );

#ifndef QT_NO_TRANSLATION
QString KSnapshotWidget::tr( const char *s, const char *c )
{
    if ( qApp )
	return qApp->translate( "KSnapshotWidget", s, c, QApplication::DefaultCodec );
    else
	return QString::fromLatin1( s );
}
#ifndef QT_NO_TRANSLATION_UTF8
QString KSnapshotWidget::trUtf8( const char *s, const char *c )
{
    if ( qApp )
	return qApp->translate( "KSnapshotWidget", s, c, QApplication::UnicodeUTF8 );
    else
	return QString::fromUtf8( s );
}
#endif // QT_NO_TRANSLATION_UTF8

#endif // QT_NO_TRANSLATION

QMetaObject* KSnapshotWidget::staticMetaObject()
{
    if ( metaObj )
	return metaObj;
    QMetaObject* parentObject = QWidget::staticMetaObject();
    static const QUParameter param_slot_0[] = {
	{ 0, &static_QUType_int, 0, QUParameter::Out }
    };
    static const QUMethod slot_0 = {"previewWidth", 1, param_slot_0 };
    static const QUParameter param_slot_1[] = {
	{ 0, &static_QUType_int, 0, QUParameter::Out }
    };
    static const QUMethod slot_1 = {"previewHeight", 1, param_slot_1 };
    static const QUMethod slot_2 = {"languageChange", 0, 0 };
    static const QUParameter param_slot_3[] = {
	{ "mode", &static_QUType_int, 0, QUParameter::In }
    };
    static const QUMethod slot_3 = {"slotModeChanged", 1, param_slot_3 };
    static const QUMethod slot_4 = {"slotNewClicked", 0, 0 };
    static const QUMethod slot_5 = {"slotSaveClicked", 0, 0 };
    static const QUMethod slot_6 = {"slotCopyClicked", 0, 0 };
    static const QUMethod slot_7 = {"slotPrintClicked", 0, 0 };
    static const QUMethod slot_8 = {"slotStartDrag", 0, 0 };
    static const QMetaData slot_tbl[] = {
	{ "previewWidth()", &slot_0, QMetaData::Public },
	{ "previewHeight()", &slot_1, QMetaData::Public },
	{ "languageChange()", &slot_2, QMetaData::Protected },
	{ "slotModeChanged(int)", &slot_3, QMetaData::Protected },
	{ "slotNewClicked()", &slot_4, QMetaData::Protected },
	{ "slotSaveClicked()", &slot_5, QMetaData::Protected },
	{ "slotCopyClicked()", &slot_6, QMetaData::Protected },
	{ "slotPrintClicked()", &slot_7, QMetaData::Protected },
	{ "slotStartDrag()", &slot_8, QMetaData::Protected }
    };
    static const QUMethod signal_0 = {"newClicked", 0, 0 };
    static const QUMethod signal_1 = {"saveClicked", 0, 0 };
    static const QUMethod signal_2 = {"copyClicked", 0, 0 };
    static const QUMethod signal_3 = {"printClicked", 0, 0 };
    static const QUMethod signal_4 = {"startImageDrag", 0, 0 };
    static const QMetaData signal_tbl[] = {
	{ "newClicked()", &signal_0, QMetaData::Public },
	{ "saveClicked()", &signal_1, QMetaData::Public },
	{ "copyClicked()", &signal_2, QMetaData::Public },
	{ "printClicked()", &signal_3, QMetaData::Public },
	{ "startImageDrag()", &signal_4, QMetaData::Public }
    };
    metaObj = QMetaObject::new_metaobject(
	"KSnapshotWidget", parentObject,
	slot_tbl, 9,
	signal_tbl, 5,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    cleanUp_KSnapshotWidget.setMetaObject( metaObj );
    return metaObj;
}

void* KSnapshotWidget::qt_cast( const char* clname )
{
    if ( !qstrcmp( clname, "KSnapshotWidget" ) )
	return this;
    return QWidget::qt_cast( clname );
}

// SIGNAL newClicked
void KSnapshotWidget::newClicked()
{
    activate_signal( staticMetaObject()->signalOffset() + 0 );
}

// SIGNAL saveClicked
void KSnapshotWidget::saveClicked()
{
    activate_signal( staticMetaObject()->signalOffset() + 1 );
}

// SIGNAL copyClicked
void KSnapshotWidget::copyClicked()
{
    activate_signal( staticMetaObject()->signalOffset() + 2 );
}

// SIGNAL printClicked
void KSnapshotWidget::printClicked()
{
    activate_signal( staticMetaObject()->signalOffset() + 3 );
}

// SIGNAL startImageDrag
void KSnapshotWidget::startImageDrag()
{
    activate_signal( staticMetaObject()->signalOffset() + 4 );
}

bool KSnapshotWidget::qt_invoke( int _id, QUObject* _o )
{
    switch ( _id - staticMetaObject()->slotOffset() ) {
    case 0: static_QUType_int.set(_o,previewWidth()); break;
    case 1: static_QUType_int.set(_o,previewHeight()); break;
    case 2: languageChange(); break;
    case 3: slotModeChanged((int)static_QUType_int.get(_o+1)); break;
    case 4: slotNewClicked(); break;
    case 5: slotSaveClicked(); break;
    case 6: slotCopyClicked(); break;
    case 7: slotPrintClicked(); break;
    case 8: slotStartDrag(); break;
    default:
	return QWidget::qt_invoke( _id, _o );
    }
    return TRUE;
}

bool KSnapshotWidget::qt_emit( int _id, QUObject* _o )
{
    switch ( _id - staticMetaObject()->signalOffset() ) {
    case 0: newClicked(); break;
    case 1: saveClicked(); break;
    case 2: copyClicked(); break;
    case 3: printClicked(); break;
    case 4: startImageDrag(); break;
    default:
	return QWidget::qt_emit(_id,_o);
    }
    return TRUE;
}
#ifndef QT_NO_PROPERTIES

bool KSnapshotWidget::qt_property( int id, int f, QVariant* v)
{
    return QWidget::qt_property( id, f, v);
}

bool KSnapshotWidget::qt_static_property( QObject* , int , int , QVariant* ){ return FALSE; }
#endif // QT_NO_PROPERTIES
